package Aocl.StarTrek;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import Meta4Framework.TuPle;

public class Crewman extends TuPle<Database> {
    @Override                     // needed by framework 
    public String TupleTypeName() { return "Crewman"; }

    public String fname;
    public String lname;
    public Starship onBoard;
    private String _onBoard;  // needed by database loader

    public Crewman(String id, String fname, String lname, Starship onBoard) {
       this.id = id;
       this.fname = fname;
       this.lname = lname;
       this.onBoard = onBoard;
    }

    // constructors used in database loading
    protected Crewman() {}

    public Crewman(String id, String fname, String lname) {
       this.id = id;
       this.fname = fname;
       this.lname = lname;
       this.onBoard = null;
    }

    private Crewman initFields(Tuple t) {
       id = t.get("id");
       fname = t.get("fname");
       lname = t.get("lname");
       _onBoard = t.get("onBoard");
       return this;
    }

    public static Crewman make(Tuple t) {
       return new Crewman().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
       if(!_onBoard.equals("null"))
           onBoard = db.Starship.getTuple(_onBoard,er);
    }
    // end of methods used for loading a database


    private static final String fmt = "Crewman(%s,%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,fname,lname,__(onBoard));
    }

    public StarshipTable onBoard() {
       return new StarshipTable(db,this.onBoard);
    }  // diamondleft

}
