package CD;

import java.io.PrintStream;
import java.util.LinkedList;

public class AssocSchema {
    protected boolean virtual = false;  // used only by cdspecs
    
    public boolean isVirtual() {
        return virtual;
    }
    
    public void setVirtual() {
        virtual = true;
    }
    
    public void setVirtual(boolean value) {
        virtual = value;
    }
    
    //--------------------------

    static int cnt = 1;

    String class1, role1, class2, role2, name;
    private atype at1, at2;
    private int min1, max1, min2, max2;
    
    public AssocSchema() { }
    
    public AssocSchema copy() {
        AssocSchema n = new AssocSchema();
        n.class1 = class1;
        n.role1 = role1;
        n.class2 = class2;
        n.role2 = role2;
        n.name = name;
        n.at1 = at1;
        n.at2 = at2;
        n.min1 = min1;
        n.min2 = min2;
        n.max1 = max1;
        n.max2 = max2;
        return n;
    }
    
    public final static int inf = 100;
    public static enum atype {
        DIAMOND(0, 1, "OPT"), 
        BLACK_DIAMOND(1, 1, "ONE"), 
        BLANK(0, inf, "STAR"), 
        ONESTAR(1,inf, "ONESTAR"),
        CUSTOM(-1,-1, "CUSTOM");

        public final static int infinity = inf;
        public final static String infs = String.format("%d",inf);
        public final int min;
        private final int max;
        private final String alt;
        
        public static atype convert(String x) {
            for (atype a : atype.values()) {
                if (x.equals(a.name()) || x.equals(a.alt))
                    return a;
            }
            return CUSTOM;
        }
        
        public int getMax() {
            return c(max);
        }

        atype(int mn, int mx, String altern) {
            min = mn;
            max = mx;
            alt = altern;
        }
        
        public boolean isDiamond() {
            return max==1;
        }
        
        public String isDiamondString() {
            return (max==1)?"true":"false";
        }

        public boolean geq(atype a) { // see gif in folder
            
            if (min==1 && max==1)
                return true;
            
            if (min==0 && max==1) 
                return !(a.min==1 && a.max==1); 
            
            return !((a.min==1 || a.min==0) && (a.max==1));
        }

        public int getMin() {
            return min;
        }

        public static class MinMax {

            boolean OK = false;
            int min = 0;
            int max = 0;

            public MinMax(String x) {
                if (x.contains(":")) {
                    String mm[] = x.split(":");
                    if (mm.length == 2) {
                        OK = true;
                        min = Integer.parseInt(mm[0]);
                        if (mm[1].equals("*") || mm[1].equals("-1")) {
                            max = -1;
                        } else {
                            max = Integer.parseInt(mm[1]);
                        }
                    }
                }
            }
        }
    }
 
        
    // all except joinkey cannot be null

    public AssocSchema(String name, String class1, String role1, atype at1, String class2, String role2, atype at2) {
        this.name = name;
        this.class1 = class1;
        this.role1 = role1;
        this.at1 = at1;
        this.min1 = at1.min;
        this.max1 = at1.max;
        this.class2 = class2;
        this.role2 = role2;
        this.at2 = at2;
        this.min2 = at2.min;
        this.max2 = at2.max;
        patch(name, class1, role1, class2, role2);
    }

    public AssocSchema(String name, String class1, String role1, int min1, int max1,
            String class2, String role2, int min2, int max2) {
        this.name = name;
        this.class1 = class1;
        this.role1 = role1;
        this.at1 = atype.CUSTOM;
        this.min1 = min1;
        this.max1 = max1;
        if (max1 > atype.infinity) {
            System.err.format("max1 value of %s exceeds %s", name, atype.infinity);
        }
        this.class2 = class2;
        this.role2 = role2;
        this.at2 = atype.CUSTOM;
        this.min2 = min2;
        this.max2 = max2;
        if (max2 > atype.infinity) {
            System.err.format("max2 value of %s exceeds %s", name, atype.infinity);
        }
        patch(name, class1, role1, class2, role2);
    }

    private void patch(String name, String class1, String role1, String class2, String role2) {
        if (name.equals("")) {
            this.name = class1 + role1 + class2 + role2;
        }
        this.role1 = role1.equals("") ? "null" : role1;
        this.role2 = role2.equals("") ? "null" : role2;
    }
    
    public void renameClass(String oldName, String newName) {
        if (class1.equals(oldName)) {
            class1 = newName;
        }
        if (class2.equals(oldName)) {
            class2 = newName;
        }
    }
    
    // used in computing virtual cdspecs; not clear if it is useful
    // elsewhere 
    public void rename(String newName) {
        name = newName;
    }
    
    public String signature() {
        return name + "." + class1 + "." + class2;
    }

    // remember this is directed -- two associations will  be equal if
    // the have all the same values (except for id).
    public AssocSchema(LinkedList<String> parsed) {
//        int len = parsed.size();
//        if (len == 6 || len == 8) {  // if new syntax used
//            name = "l" + cnt++;
//            len++;
//        } else {                     // old syntax
            name = parsed.removeFirst();
//        }

        class1 = parsed.removeFirst();
        role1 = parsed.removeFirst();
        String next = parsed.removeFirst();
        atype x = atype.convert(next);
        if (x != atype.CUSTOM) {
            at1 = x; 
            min1 = at1.min;
            max1 = at1.max;
        } else {
            at1 = atype.CUSTOM;
            min1 = Integer.parseInt(next);
            max1 = Integer.parseInt(parsed.removeFirst());
            if (min1<0 || max1>inf) {
                String msg = String.format("min (%d) or max (%d) out of range",min1,max1);
                throw new RuntimeException(msg);
            }
        }
        class2 = parsed.removeFirst();
        role2 = parsed.removeFirst();
        next = parsed.removeFirst();
        x = atype.convert(next);
        if (x != atype.CUSTOM) {
            at2 = x;
            min2 = at2.min;
            max2 = at2.max;
        } else {
            at2 = atype.CUSTOM;
            min2 = Integer.parseInt(next);
            max2 = Integer.parseInt(parsed.removeFirst());
            if (min2<0 || max2>inf) {
                String msg = String.format("min (%d) or max (%d) out of range",min2,max2);
                throw new RuntimeException(msg);
            }
        }
        patch(name, class1, role1, class2, role2);
    }

    public String getClass1() {
        return class1;
    }

    public String getClass2() {
        return class2;
    }

    public String getRole1() {
        return role1;
    }

    public String getRole2() {
        return role2;
    }

    public atype getAt1() {
        return at1;
    }

    public int getMin1() {
        return min1;
    }

    public int getMax1() {
        if (max1==inf) 
            return -1;
        return max1;
    }

    public atype getAt2() {
        return at2;
    }

    public int getMin2() {
        return min2;
    }

    public int getMax2() {
        if (max2==inf)
            return -1;
        return max2;
    }

    public String getName() {
        return name;
    }

    public AssocSchemaSpec getAssocSchemaSpec() {
        return new AssocSchemaSpec(name,class1,role1,at1,class2,role2,at2);
    }
    
    public boolean equals(AssocSchema other) {
        return name.equals(other.name) && at1.equals(other.at1)
                && at2.equals(other.at2)
                && class1.equals(other.class1) && class2.equals(other.class2)
                && role1.equals(other.role1) && role2.equals(other.role2);
    }

    private String atype2String(atype a, int min, int max) {
        if (a==atype.CUSTOM)
            return String.format("%d:%d",min,max);
        return a.name();
    }
    
    public String toString() {
        String a1 = atype2String(at1,min1,max1);
        String a2 = atype2String(at2,min2,max2);
        return String.format("assoc(%s,%s,%s,%s,%s,%s,%s).\n",
                name, class1, role1, a1, class2, role2, a2);
//        if (at1==atype.CUSTOM || at2==atype.CUSTOM) {
//            return String.format("assoc(%s,%s,%s,%d,%d,%s,%s,%d,%d).\n",
//                name, class1, role1, min1, c(max1), class2, role2, min2, c(max2));
//        } else
//        return String.format("assoc(%s,%s,%s,%s,%s,%s,%s).\n",
//                name, class1, role1, at1.toString(), class2, role2, at2.toString());
    }
    
    private static int c(int x) {
        return (x==inf)?-1:x;
    }

    public void print(PrintStream out) {
        out.println(this);
    }

    public void print() {
        print(System.out);
    }
}
