package CD;

import java.io.PrintStream;
import java.util.LinkedList;

public class ConsSchema {

    String name;          // name of constraint
    String consType;      // type of constraint
    String constraint;    // string of constraint
    
    public ConsSchema copy() {
        return new ConsSchema(name,consType,constraint);
    }

    public ConsSchema(String name, String consType, String constraint) {
        this.name = name;
        this.consType = consType;
        this.constraint = constraint;
    }
    
    public ConsSchema(LinkedList<String> parsed) {
        name = parsed.removeFirst().trim();
        consType = parsed.removeFirst().trim();
        constraint = parsed.removeFirst().replace("'","`").replace("\"","@").trim();
        constraint = constraint.substring(0,constraint.length()-1);
    }
    
    public boolean equals(ConsSchema cs) {
        if (!consType.equals(cs.consType))
            return false;
        return constraint.trim().equals(cs.constraint.trim());
    }
    
    public String getName() {
        return name;
    }
    
    public String getConsType() {
        return consType;
    }

    public String getConstraint() {
        return constraint;
    }
    
    public void setName(String n) {
        name  = n;
    }
    
    public void setConsType(String n) {
        consType = n;
    }

    public void setConstraint(String n) {
        constraint = n;
    }

    public String toString() {
        return toStringNoCR()+"\n";
    }
    
    public String toStringNoCR() {
        return String.format("cons %s %s %s.",name,consType,constraint);
    }

    public void print(PrintStream out) {
        out.println(this);
    }

    public void print() {
        print(System.out);
    }
}
