package CD;

import java.util.HashMap;
import java.util.LinkedList;

public abstract class MinConsSuper {
    private final static HashMap<String,MinConsSuper> hm;
    
    protected ConsSchema cs;
    
    static{
        hm = new HashMap<>();
    }
    
    public static void register(String name, MinConsSuper x) {
        hm.put(name, x);
    }
    
    public static LinkedList<MinConsSuper> getMinConsSupers(CDSpec in) {
        LinkedList<MinConsSuper> result = new LinkedList<>();
        
        for (ConsSchema cs : in.getConsSchemas()) {
            MinConsSuper factory = hm.get(cs.getConsType());
            if (factory == null) {
                Tell.warn("unrecognized constraint (%s)",cs.toStringNoCR());
                continue;  // ignore jibberish
            }
            MinConsSuper mcs = factory.New(cs);
            result.add(mcs);
        }
        return result;
    }

    // standard maintenance methods
    public abstract String constName();
    public abstract String constraint();
    
    // call update() ONLY after calling MinConsSuper.getMinConsSupers()
    protected void update() {
        cs.setName(constName());
        cs.setConstraint(constraint());
    }
    
    // standard update methods
    public abstract MinConsSuper New(ConsSchema cs);
    public abstract void renameClass(String oldName, String newName);
    public abstract void renameField(String className, String oldName, String newName);
    public abstract void removeClass(CDSpec cs, String cname);
    public abstract void removeField(CDSpec cs, String cname, String fname);
}
