package CD;

import PrologDB.ErrorReport;
import PrologDB.TableSchema;

public class Tell {

    public static void warnIfTrue(boolean b, String fmt, Object... o) {
        if (b) {
            warn(fmt, o);
        }
    }

    public static void warn(String fmt, Object... o) {
        String W = "Warning : " + fmt + "\n";
        System.err.format(W, o);
    }

    //************ error routines ***********************/
    public static void exitIfTrue(boolean b, ErrorReport er, String fmt, Object... o) {
        if (b == false) {
            return;
        }
        er.add(fmt, o);
        er.printEH();
    }

    public static void exitIfTrue(boolean c, String fmt, Object... o) {
        if (c) {
            String msg = String.format(fmt, o);
            throw new RuntimeException(msg);
        }
    }

//    public static void falseThenError(boolean b, ErrorReport er, String fmt, Object... o) {
//        trueThenError(!b, er, fmt, o);
//    }

    public static void trueThenError(boolean b, ErrorReport er, String fmt, Object... o) {
        if (b) {
            er.add(fmt, o);
        }
    }

    public static void exitIfTrue() {
        throw new UnsupportedOperationException("Not supported yet.");
    }
    
    public static void exitIfAssoNoExist(String refact, CDSpec in, String assoName, String class1, String role1, String class2, String role2) {
        AssocSchema as = in.getAssocSchema(assoName);
        exitIfTrue(as==null,"association (%s) in %s does not exist",assoName,refact);
        if (role1!=null) 
            exitIfTrue(!(role1.equals(as.getRole1())),"role1 (%s) of association (%s) doesn't exist", role1,assoName);
        if (role2!=null) 
            exitIfTrue(!(role2.equals(as.getRole2())),"role2 (%s) of association (%s) doesn't exist", role2,assoName);
        exitIfTrue(!(class1.equals(as.getClass1())),"class1 (%s) of association (%s) does not exist",class1,assoName);
        exitIfTrue(!(class2.equals(as.getClass2())),"class2 (%s) of association (%s) does not exist",class2,assoName);
    }
    
    public static void exitIfClassNoExist(CDSpec in, String className, String refact) {
        TableSchema ts = in.getTableSchema(className);
        exitIfTrue(ts==null,"table (%s) in %s does not exist",className,refact);
    }
}
