package M4;

import CD.AssocSchema;
import MDLUtilities.Marquee1In_1Out;
import static MDLUtilities.RunningBear.RBSetup;
import PrologDB.PrimType;
import PrologDB.Table;
import PrologDB.Tuple;


public class CD2CDSpec  extends MDLUtilities.RunningBear {

    public static void main(String... args) {

        Marquee1In_1Out mark = new Marquee1In_1Out(CD2CDSpec.class, ".cd.pl", ".cdspec.pl", args);
        RBSetup(mark, args);
        String appName = mark.getAppName();
        
        // print classDiagram line
        l("%s %s.",M4Parsing.CDPrims.PrimTokens.CD.tok,appName);
        l();
        
        printTableDecls();
        printAssocDecls();
        printSubTableDecls();
        printConstraints();
    }
    
    private static void printTableDecls() {
        for (Tuple t : db.getTable("tab").tuples()) {
            p("table(%s,[",t.get("name"));
            String comma = "";
            for (Tuple a : t.rightSemiJoin("id", db.getTable("attr"), "attrof").tuples()) {
               if (a.is("ptype",PrimType.Str.getName())) {
                   p("%s%s",comma,a.get("name"));
               } else if (a.is("ptype", PrimType.QStr.getName())) {
                   p("%s\"%s\"",comma,a.get("name"));   
               } else {
                   p("%s%s:%s",comma,a.get("name"),a.get("ptype"));  
               }
               comma = ",";
            }
            l("]).");
        }
        l();
    }
    
    private static void printAssocDecls() { 
        for (Tuple t : db.getTable("assoc").tuples()) {
            p("assoc %s ",t.get("name"));
            printEnd(t,"1");
            p(" %s ", M4Parsing.CDPrims.PrimTokens.DDash.tok );
            printEnd(t,"2");
            l(".");
        }
        l();
    }
    
    private static void printEnd(Tuple t, String which) {
        p("%s %s ",t.get("class"+which), t.get("role"+which));
        switch( AssocSchema.atype.convert(t.get("atype"+which))) {
            case BLACK_DIAMOND:
                p("BLACK_DIAMOND");
                break;
            case DIAMOND:
                p("DIAMOND");
                break;
            case BLANK:
                p("BLANK");
                break;
            case CUSTOM:
                p("%s %s",t.get("min"+which),t.get("max"+which));
                break;
        }
    }
    
    private static void printSubTableDecls() {
        Table tab = db.getTable("tab");
        for (Tuple t : tab.tuples()) {
            Table subs = t.rightSemiJoin("id", db.getTable("sub"), "suptab");
            if (subs.isEmpty())
                continue;
            p("subtable(%s,[",t.get("name"));
            for (Tuple s : t.rightSemiJoin("id", db.getTable("sub"), "suptab").tuples()) {
               String comma = "";
               Tuple tbl = tab.followEH(s.get("suptab"));
               
               p("%s%s",comma,tbl.get("name"));
               comma = ",";
            }
            l("]).");
        }
        l();
    }
    
    private static void printConstraints() {
        for (Tuple c : db.getTable("cons").tuples()) {
            l("cons %5s %s.",c.get("name"), c.get("constraint").replace("@","\""));
        }
        l();
    }
}
