package M4;

import CD.CDConform;
import CD.CDSpec;
import MDLUtilities.Marquee2In_1Out;
import PrologDB.DB;

public class CDSpecUnion {
    static final String CDSpecEnd = ".cdspec.pl";
    
    public static void main(String... args) {
        // Step 0: standard marquee processing
        Marquee2In_1Out mark = new Marquee2In_1Out(CDSpecUnion.class, CDSpecEnd, CDSpecEnd, CDSpecEnd, args);
        String oldCDSpecFile = mark.getInputFileName();
        String newCDSpecFile = mark.getInputFileName1();
        String UnionCDSpecFile = mark.getInputFileName2();
        String AppName = mark.getAppName(UnionCDSpecFile,CDSpecEnd);
        
        // Step 1: read both CDspecs
        CDSpec oldSpec = CDSpec.read(oldCDSpecFile);
        CDSpec newSpec = CDSpec.read(newCDSpecFile);
        
        // Step 2: now do the work
        main(oldSpec, newSpec, UnionCDSpecFile, AppName);
    }
    
    public static void main(CDSpec oldSpec, CDSpec newSpec, String UnionCDSpecFile, String AppName) {
        
        // Step 1: Convert to CD and run conform
        DB dbold = oldSpec.toCD();
        CDConform.check(dbold);
        DB dbnew = newSpec.toCD();
        CDConform.check(dbnew);
        
        // Step 2: form directedUnion
        CDSpec unionSpec = oldSpec.directedUnion(newSpec);   // unionSpec has lots of sharing
        unionSpec.clearVirtual();
        unionSpec.assignVirtualAndPatch(newSpec);
        
        // Step 3: write out unionSpec -- cannot return it as it has shared components
        unionSpec.rename(AppName);
        unionSpec.addExtra(AppName);
        unionSpec.printSpecial(UnionCDSpecFile);
    }
}
