package M4;

import MDLUtilities.Marquee1In_1Out;
import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import net.sourceforge.plantuml.SourceStringReader;

public class PlantUML2Png {
    static final String plantuml = ".class.plantuml";
    static final String png = ".class.png";

    /**
     * @param args (basically the X.plantuml input file; X.png is output
     */
    public static void main(String... args) {
        try {
        Marquee1In_1Out mark = new Marquee1In_1Out(PlantUML2Png.class, plantuml, png, args);
        String inputFileName = mark.getInputFileName();
        String outputFileName = getOutputFileName(args,inputFileName);
        
        BufferedReader br;
        String entireFile ="", line;

        try {
            FileReader in = new FileReader(inputFileName);
            br = new BufferedReader(in);
            while (true) {
                line = br.readLine();
                if (line == null) {
                    break;
                }
                if (line.equals(""))
                       continue;
                entireFile += 
                        
                        
                        
                        line + "\n";
            }
            br.close();
        } catch(IOException e) {
            throw MDLUtilities.Error.toss(MDLUtilities.Error.ioerror,inputFileName, e.getMessage());
        }
        
         // http://plantuml.com/api
        OutputStream png = new FileOutputStream(outputFileName);
        SourceStringReader reader = new SourceStringReader(entireFile );
        // Write the first image to "png"
        String desc = reader.outputImage(png).getDescription();
        // Return a null string if no generation
        if (desc==null)
            throw MDLUtilities.Error.toss(MDLUtilities.Error.ioerror,inputFileName, "no png output produced!");
        else
            System.out.format("%s\n", desc);
        //DisplayClassPng.main(outputFileName);
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
        }
//        // http://plantuml.com/api
//        File plantFile = new File(inputFileName);
//        SourceFileReader reader = new SourceFileReader(plantFile);
//        List<GeneratedImage> list = reader.getGeneratedImages();
//        System.out.format("%d image(s) produced\n", list.size());
    }
    
    
    static String getOutputFileName(String[] args, String inputFileName) { 
        if (args.length==2)
            return args[1];
        if (inputFileName.contains("/")) {
            int x = inputFileName.lastIndexOf('/');
            String y= inputFileName.substring(x+1).replace(plantuml, "")+png;
            return y;
        }
        if (inputFileName.endsWith(plantuml))
            return inputFileName.replace(plantuml,png);
        return inputFileName+png;
    }
    
}
