package M4Parsing.CDPrims.Patterns;

import M4Parsing.CDPrims.PrimTokens.DDash;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/**
 * Assoc statement: assoc(id,end1,role1,key,end2,role2).
 */
public class AssocNew extends Pattern {

    /** Standard constructor */
    public AssocNew() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public AssocNew(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            { new Name(),  // name of association
              new Name(), new Name(), new CardOrName(), // class1 role1 type1
              new DDash(),
              new Name(), new Name(), new CardOrName(), // class2 role2 type2
              new Dot(), new End()};
            sequence = s;
        }
        return sequence;
    }

    @Override
    public AssocNew klone(LineToParse l) {
        return new AssocNew(l);
    }
}
