package M4Parsing.CDPrims.Patterns;

import M4Parsing.CDPrims.PrimTokens.Assoc;
import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;

/**
 * Assoc statement: assoc(id,end1,role1,key,end2,role2).
 */
public class AssocStmt extends Pattern {

    /** Standard constructor */
    public AssocStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public AssocStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            { new Assoc(), new Choose1( new AssocNew(), new AssocOld()) };
//            {new Assoc(), new LeftParen(), 
//                new Name(), new Comma(), // Name of association
//                new Name(), new Comma(), // Class1
//                new Name(), new Comma(), // role1 (of class1)
//                new CardOrName(), new Comma(), // type1
//                new Name(), new Comma(), // Class2
//                new Name(), new Comma(), // role2
//                new CardOrName(),              // type2
//                new RightParen(), new Dot(), new End()};
            sequence = s;
        }
        return sequence;
    }

    @Override
    public AssocStmt klone(LineToParse l) {
        return new AssocStmt(l);
    }
}
