package M4Parsing.CDPrims.Patterns;

import M4Parsing.CDPrims.PrimTokens.CD;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/**
 * classDiagram statement: classDiagram(name,[name1,name2...]).
 */
public class CDStmt extends Pattern {

    /** Standard constructor */
    public CDStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public CDStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new CD(), new Name(), new Dot(), new End()};
            sequence = s;
        }
        return sequence;
    }

    @Override
    public CDStmt klone(LineToParse l) {
        return new CDStmt(l);
    }
}
