package M4Parsing.CDPrims.Patterns;

import M4Parsing.CDPrims.PrimTokens.Cons;
import M4Parsing.CDPrims.PrimTokens.DollarEndedString;
import M4Parsing.CDPrims.PrimTokens.EoLString;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/**
 * classDiagram statement: classDiagram(name,[name1,name2...]).
 */
public class ConsStmt extends Pattern {

    /** Standard constructor */
    public ConsStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public ConsStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new Cons(), new Name(), new Name(), new EoLString()}; //new DollarEndedString(), new Dot(), new End()};
            sequence = s;
        }
        return sequence;
    }

    @Override
    public ConsStmt klone(LineToParse l) {
        return new ConsStmt(l);
    }
}
