package M4Parsing.CDPrims.Patterns;

import Parsing.DBPrimitives.FixedStrTokens.Comma;
import Parsing.GeneralPrimitives.NonEmptyList;
import Parsing.LineParsers.LineToParse;

/**
 * classDiagram statement: classDiagram(name,[name1,name2...]).
 */
public class FieldNameList extends NonEmptyList {

    /** Standard constructor */
    public FieldNameList() {
        super(new FieldName(), new Comma(), true);
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public FieldNameList(LineToParse l) {
        super(new FieldName(), new Comma(),l, true);
    }
    

    @Override
    public FieldNameList klone(LineToParse l) {
        return new FieldNameList(l);
    }
}
