package M4Parsing.CDPrims.Patterns;

import M4Parsing.CDPrims.PrimTokens.VField;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.LineParsers.LineToParse;

/**
 * Assoc statement: assoc(id,end1,role1,key,end2,role2).
 */
public class VirtualFldStmt extends Pattern {

    /** Standard constructor */
    public VirtualFldStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public VirtualFldStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            { new VField(), new FieldNameList(),new Dot(), new End() };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public VirtualFldStmt klone(LineToParse l) {
        return new VirtualFldStmt(l);
    }
}
