package M4Parsing.CDPrims.Patterns;

import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;

/**
 * Assoc statement: assoc(id,end1,role1,key,end2,role2).
 */
public class VirtualStmt extends Pattern {
    public static final String tok = "V";

    /** Standard constructor */
    public VirtualStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public VirtualStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            { new Choose1( new VirtualFldStmt(), new VirtualClsStmt(), new VirtualAssStmt(), new VirtualXtraStmt()) };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public VirtualStmt klone(LineToParse l) {
        return new VirtualStmt(l);
    }
}
