package M4Parsing.CDPrims.Patterns;

import M4Parsing.CDPrims.PrimTokens.VClass;
import M4Parsing.CDPrims.PrimTokens.VExtra;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.DBPrimitives.Lists.NameList;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.LineParsers.LineToParse;


public class VirtualXtraStmt extends Pattern {

    /** Standard constructor */
    public VirtualXtraStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public VirtualXtraStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            { new VExtra(), new NameList(), new Dot(), new End() };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public VirtualXtraStmt klone(LineToParse l) {
        return new VirtualXtraStmt(l);
    }
}
