package M4Parsing.CDPrims.PrimTokens;

import MDLUtilities.ParsE;
import Parsing.GeneralPrimitives.Token;
import Parsing.LineParsers.LineToParse;

/** (anything until $ */
public class DollarEndedString extends Token {

    /** Standard constructor */
    public DollarEndedString() {
    }
    
    /** Standard constructor with line to parse
     * @param l -- line to parse
     */
    public DollarEndedString(LineToParse l) {
        super(l);
    }

    @Override
    public boolean canParse() {
        toBeParsed.AssertNotAtEnd(this);
        return true;
    }
    
    @Override
    public void consumeToken() {
        int i;
        boolean pastEnd = true;

        for (i = 0; i < toBeParsed.toParse.length(); i++) {
            char c = toBeParsed.toParse.charAt(i);
            if (c=='$') {  // end marker
                pastEnd = false;
                break;
            }
        }
        if (!pastEnd) {
           toBeParsed.returnSave(i + 1);
           return;
        }
        throw ParsE.toss(ParsE.runAwayString, toBeParsed.lineno, toBeParsed.toParse);
    }

    @Override
    public void parse() {
        toBeParsed.parseSave(this);
    }
    
    @Override
    public DollarEndedString klone(LineToParse l) {
        return new DollarEndedString(l);
    }
    
    @Override
    public String getEmsg() { return "quoted string"; }
}
