package M4Parsing.CDPrims.PrimTokens;

import MDLUtilities.ParsE;
import Parsing.GeneralPrimitives.Token;
import Parsing.LineParsers.LineToParse;

/** (anything until eol */
public class EoLString extends Token {

    /** Standard constructor */
    public EoLString() {
    }
    
    /** Standard constructor with line to parse
     * @param l -- line to parse
     */
    public EoLString(LineToParse l) {
        super(l);
    }

    @Override
    public boolean canParse() {
        toBeParsed.AssertNotAtEnd(this);
        return true;
    }
    
    @Override
    public void consumeToken() {
        int i;
        toBeParsed.returnSave(toBeParsed.toParse.length());
    }

    @Override
    public void parse() {
        toBeParsed.parseSave(this);
    }
    
    @Override
    public EoLString klone(LineToParse l) {
        return new EoLString(l);
    }
    
    @Override
    public String getEmsg() { return "end-of-line string"; }
}
