package M4Parsing.PlantUMLPrims.FixedStrTokens;

import Parsing.GeneralPrimitives.PrimTokens.*;
import Parsing.GeneralPrimitives.Token;
import Parsing.LineParsers.LineToParse;

/** name token (alpha (alpha|underscore|digit)* */
public class EntireLine extends Token {

    /** Standard constructor */
    public EntireLine() {
    }
    
    /** Standard constructor with line to parse
     * @param l -- line to parse
     */
    public EntireLine(LineToParse l) {
        super(l);
    }
    
    @Override
    public boolean canParse() { // consume name, if canParse == true
        toBeParsed.AssertNotAtEnd(this);
        char c = toBeParsed.peek();
        return c!=RightBrace.endtok;
    }
    
    @Override
    public void consumeToken() {
        int i;
        for (i = 1; i < toBeParsed.toParse.length(); i++) {
            if (!toBeParsed.isLetterOrDigitOrUnderScore(toBeParsed.toParse.charAt(i))) {
                break;
            }
        }
        toBeParsed.returnSave(toBeParsed.toParse.length());
    }
    
    @Override
    public void parse() {
        toBeParsed.parseSaveQualified(this);
    }
    
    @Override
    public EntireLine klone(LineToParse l) {
        return new EntireLine(l);
    }
    
    @Override
    public String getEmsg() { return "name"; }
}
