
package M4Parsing.PlantUMLPrims.Patterns;

// extended column declaration

import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.GeneralPrimitives.Token;
import Parsing.LineParsers.LineToParse;
import Parsing.TBPrims.SkipTokens.Colon;


// kind = ':' modifier kindname ;

public class ColonName extends Pattern {
    /** Standard constructor */
    public ColonName () {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public ColonName(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new Colon(),                                   // ":"
             new Name()                                     // kindname
            };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public Token klone(LineToParse l) {
        return new ColonName(l);
    }
    
}
