package M4Parsing.PlantUMLPrims.Patterns;

import Parsing.GeneralPrimitives.Optionals.Optional;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;
import M4Parsing.PlantUMLPrims.FixedStrTokens.Abstract;
import M4Parsing.PlantUMLPrims.FixedStrTokens.LeftBrace;

/**
 * link PlantUML statement: NAME [quotedString] LeftTags Separator RightTags [quotedString] NAME [ ColonName ] end;
 *               LeftTags : LeftSuper | Association | Aggregation | Nothing;
 *               RightTags: RightSuper | Association | Aggregation | Nothing;
 *               ColonName: ":" NAME ;
 *               Separator: "--" | ".." ;
 */
public class KlassBeginDecl extends Pattern {

    /** Standard constructor */
    public KlassBeginDecl() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public KlassBeginDecl(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {   new Optional( new Abstract() ),
                new KlassName(), 
                new LeftBrace(),
                new End(),
            };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public KlassBeginDecl klone(LineToParse l) {
        return new KlassBeginDecl(l);
    }
}
