package M4Parsing.PlantUMLPrims.Patterns;

import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;

/**
 * link PlantUML statement: NAME [quotedString] LeftTags Separator RightTags [quotedString] NAME [ ColonName ] end;
 *               LeftTags : LeftSuper | Association | Aggregation | Nothing;
 *               RightTags: RightSuper | Association | Aggregation | Nothing;
 *               ColonName: ":" NAME ;
 *               Separator: "--" | ".." ;
 */
public class KlassDecl extends Pattern {

    /** Standard constructor */
    public KlassDecl() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public KlassDecl(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {   new KlassName(), 
                new End(),
            };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public KlassDecl klone(LineToParse l) {
        return new KlassDecl(l);
    }
}
