package M4Parsing.PlantUMLPrims.Patterns;

import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;
import M4Parsing.PlantUMLPrims.FixedStrTokens.RightBrace;

/**
 * link PlantUML statement: NAME [quotedString] LeftTags Separator RightTags [quotedString] NAME [ ColonName ] end;
 *               LeftTags : LeftSuper | Association | Aggregation | Nothing;
 *               RightTags: RightSuper | Association | Aggregation | Nothing;
 *               ColonName: ":" NAME ;
 *               Separator: "--" | ".." ;
 */
public class KlassEndDecl extends Pattern {

    /** Standard constructor */
    public KlassEndDecl() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public KlassEndDecl(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {   new RightBrace(),
                new End(),
            };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public KlassEndDecl klone(LineToParse l) {
        return new KlassEndDecl(l);
    }
}
