package Meta4;

import static MDLUtilities.RunningBear.l;
import PrologDB.OOSchema;
import java.io.PrintStream;

public class LangFile extends MDLUtilities.RunningBear {

    static class Four {

        String FNAME, RNAME, SNAME, JNAME, FMT, PFMT;  // fake, real, short for parseREAL, javaname ****, FORMAT, %FORMAT

        Four(String f, String r, String s, String j, String fmt) {
            FNAME = f;
            RNAME = r;
            SNAME = s;
            JNAME = j;
            FMT   = fmt;
            PFMT  = "%"+fmt;
        }
    }

    static Four[] theList = {
        new Four("STRING", "String", "", "String", "s"),
        new Four("INT", "Integer", "Int", "int", "d"),
        new Four("FLOAT", "Float", "Float", "float", "f"),
        new Four("DOUBLE", "Double", "Double", "double", "f"),
        new Four("BOOL", "Boolean", "Boolean", "boolean", "b")
    };

    public static void makeLangFile(OOSchema o) {
        String filename = Main.AoclDir + "/" + o.getName() + "/Lang.java";
        openOut(filename);
        l("package %s.%s;", Main.AoclDir, o.getName());
        l();
        l("import Meta4Framework.*;");
        l("import PrologDB.Tuple;");
        l("import PrologDB.ErrorReport;");
        l("import java.io.PrintStream;");
        l("import java.util.Arrays;");
        l("import java.util.LinkedList;");
        l();
        l("public class Lang {");
        for (Four p : theList) {
            String f = p.FNAME;  //  "INT"   see **** above
            String r = p.RNAME;  // "Integer"
            String s = p.SNAME;  // Int
            String j = p.JNAME;  // int
            l();
            l("/**************  %s ******************/", f);
            l();
            l("    public static class %s extends PrimTuPle<Database, %s> {", f, r);
            l("       @Override");
            l("       public String TupleTypeName() { return \"%s\"; };",f);
            if (f.equals("STRING")) {
                l("       public STRING(String value) { this.value = value; this.id = value; }");
                l("       public static int compareTo(String x, String y) { return x.compareTo(y); }");
                l("       public static int compareTo(STRING x, STRING y) { return x.value.compareTo(y.value); }");
            } else {
                l("       public %s(%s value) { this.value = value; this.id = value+\"\"; }", f, r);
                if (f.equals("BOOL")) {
                    l("       public static int compareTo(%s x, %s y) { return x&&!y?1: (x==y)? 0 : -1; }", j, j);
                } else {
                    l("       public static int compareTo(%s x, %s y) { return x > y?1: (x==y)? 0 : -1; }", j, j);
                }
                l("       public static int compareTo(%s x, %s y) { return compareTo(x.value,y.value); }", f, f);
            }
            l("       @Override");
            l("       public void finishTuple(Database db, ErrorReport er) {}");
            l("       @Override");
            l("       public String toString(String fmt) { return String.format(fmt, value); }");
            l("       public %sTable toTable() { return new %sTable(db,this); }",f,f);
            l("    }");
            l();
            l("    public static class %sTable extends TaBle<Database, %s, %sTable> {", f, f, f);
            l("       @Override");
            l("       public String TupleTypeName() { return \"%s\"; };", f);
            l("       public %sTable(Database db) { this.db = db; initTupleList(null); }", f);
            l("       public %sTable(Database db, %s t) { this.db = db; initTupleList(t); }", f, f);
            l("       public boolean contains(%s x) {", r);
            l("           for (%s s : tuples()) ", f);
            l("               if (s.value.equals(x))");
            l("                   return true;");
            l("           return false;");
            l("       }");
            l("       @Override");
            l("       public %sTable duplicates() {", f);
            l("           LinkedList<%s> unique = new LinkedList<>();", r);
            l("           %sTable dups = New();", f);
            l("           for (%s t : tuples()) {", f);
            l("               if (!unique.contains(t.value)) {");
            l("                   unique.add(t.value);");
            l("               } else if (!dups.contains(t.value)){");
            l("                   dups.add(t);");
            l("               }");
            l("           }");
            l("           return dups;");
            l("       }");
            l("       @Override");
            l("       public boolean deleteFromSubTables(%s t) { return false; }",f);
            l("       @Override");
            if (f.equals("STRING")) {
                l("       public void makeAndAdd(Tuple t) { this.add(new %s(t.getId())); }", f);
            } else {
                l("       public void makeAndAdd(Tuple t) { this.add(new %s(%s.parse%s(t.getId()))); }", f, r, s);
            }
            l("       @Override");
            l("       public %sTable New() { return new %sTable(db); }", f, f);
            l("       @Override");
            l("       public LinkedList<%s> tuples() { return tuples; }", f);
            l("       @Override");
            l("       public void mastHead(PrintStream out) {out.format(\"table(%sTable,[value]).\\n\");}", f);
            l("       @Override");
            l("       public void cascadingDeleteLocal(%s t) {}",f);
            l("       @Override");
            l("       public String pformat() { return \"%s\\n\"; }",p.PFMT);
            l("       @Override");
            l("       public String ppformat(boolean local) {");
            l("          int i=0;");
            l("          for (%s a : local?tuples:tuples())",f);
            if (f.equals("STRING"))
                l("          { i = Math.max(i,a.value.length()); }");
            else
                l("          { i = Math.max(i,(\"\"+a.value).length()); }");
            l("          return \"%s\"+i+\"%s\\n\";","%",p.FMT);
            l("       }");
            l("    }");
            l();
        }
        makeDTable();
        l("}");
        closeOut();
    }

    private static void makeDTable() {
        l("/**************  DTuple ******************/");
        l(1);
        l("    public static class DTuple  {");
        l("       DTable belongsTo = null;");
        l("       LinkedList<String> values = new LinkedList<>();");
        l("       public DTuple(String... vals) { values.addAll(Arrays.asList(vals)); }");
        l("       public String get(int i) { return values.get(i);}");
        l("       public void put(int i, String v) { values.set(i, v);}");
        l("       public int size() { return values.size();}");
        l("       @Override");
        l("       public String toString() {  String result = (belongsTo==null? \"\": belongsTo.name)+ \"(\"; String comma = \"\";");
        l("          for (String v:values) { result += comma + v; comma = \",\"; }");
        l("          return result+\").\";");
        l("       }");
        l("    }");
        l(1);
        l("    public static class DTable  {");
        l("       String name;");
        l("       public LinkedList<DTuple> tuples = new LinkedList<>();");
        l("       LinkedList<String> colnames = new LinkedList<>();");
        l("       public DTable(String name, String... cols) { this.name=name; colnames.addAll(Arrays.asList(cols)); }");
        l("       public void add(DTuple t) {");
        l("           if (t.size()!=colnames.size()) {");
        l("               String msg = \"tuple size (\"+t.size()+\") does not match table size (\"+colnames.size()+\")\";");
        l("               throw new RuntimeException(msg);");
        l("           }");
        l("           tuples.add(t);");
        l("           t.belongsTo=this;");
        l("       }");
        l("       public void add(String... vals) {");
        l("           DTuple d = new DTuple(vals);");
        l("           add(d);");
        l("       }");
        l("       @Override");
        l("       public String toString() { ");
        l("           String result = \"table(\"+name+\",[\";  String comma = \"\";");
        l("           for (String c: colnames) { result += comma + c; comma = \",\"; } result +=\"]).\";");
        l("           for (DTuple d : tuples) {  result += \"\\n\"+d; }");
        l("           return result +\"\\n\";");
        l("       }");
        l("       public void print(PrintStream out) { out.print(this); }");
        l("       public void print() { System.out.print(this); }");
        l("    }");
        l(1);
    }
}
