
package Meta4;

import CD.CDSpec;
import CD.AssocSchema;
import CD.AssocSchema.atype;
import Parsing.TBPrims.SaveToken.Opt;
import PrologDB.DBSchema;
import PrologDB.TableSchema;
import PrologDB.Column;

public class SchemaFile {
    static final String dbend = ".schema.pl";
    
    public static void addAssocFieldsAndTables(CDSpec s) {
        // WARNING -- this method modifies CDSchema s
        // it must be the last (or before finishAndPrint) method that is invoked!!!
        s.setUnfinished();
        
        // Step 1: review the associations, add fields to existing tables
        //         and add association tables
        for (AssocSchema as : s.getAssocSchemas()) {
            Column c,c1;
            TableSchema ts;
            
//            if (as.isVirtual())
//                continue;
            
            // Step 1a: getAssocSchemaSpec raw data
            String e1 = as.getClass1();
            String e2 = as.getClass2();
            String r1 = as.getRole1();
            String r2 = as.getRole2();
            String ml = as.getName();
            
            // Step 1b: deal with nulls
            r1 = r1.equals("null")?ml:r1;
            r2 = r2.equals("null")?ml:r2;
            
            atype at = as.getAt1();
            boolean v = as.isVirtual();
            
            switch(at) {
                case BLACK_DIAMOND:
                    ts = s.getTableSchemaEH(e2);
                    c = new Column(mkCol(r1,e1,false)).setVirtual(v);
                    ts.add(c);
                    break;
                case DIAMOND:
                    ts = s.getTableSchemaEH(e2);
                    c = new Column(mkCol(r1,e1,true)).setVirtual(v);
                    ts.add(c);
                    break;
                case BLANK:
                    ts = new TableSchema(ml);
                    c = new Column(mkCol(r1,e1,false)).setVirtual(v);
                    c1 = new Column(mkCol(r2,e2,false)).setVirtual(v);
                    ts.add(c,c1);
                    s.add(ts);
                    break;
            }
        }
        // done!
        s.addIdentifiersToAllNonSubtables();
        s.setFinished();
    }

    public static void finishAndPrint(CDSpec s) {
        // Step 1: a CD schema is also an ooschema.  propagate its attributes
        //         and produce a printable db
        DBSchema db = s.finishAndPropagateAttributes();
        String fname = String.format("%s/%s/%s.schema.pl",Main.AoclDir, s.getName(),db.getName());
        db.print(fname);
    }
    
    private static String mkCol(String fieldName, String kind, boolean optional) {
        return fieldName + ":" + (optional?(Opt.tok+" "):"") + kind;
    }

}
