package Meta4Framework.A;

import java.util.function.Function;

public class Average<T> implements Reducer<T> {
    double agg;
    int count;
    Function<T,Double> val;
            
    public Average(Function<T,Double> val) {
       this.val = val;
       reset();
    }

    @Override
    public void add(T t) {
        agg = agg +  val.apply(t);
        count++;
    }

    @Override
    public Object getAccumulated(int i) {
        return agg/count;
    }

    @Override
    public void reset() {
        agg = 0.0;
        count = 0;
    }
    
    @Override
    public int resultCount() { return 1; }
}
