package Meta4Framework.A;

import java.util.function.Function;

public class DoubleSum<T> implements Reducer<T> {

    Double agg;
    Function<T, Double> val;

    public DoubleSum(Function<T, Double> val) {
        this.val = val;
        reset();
    }

    @Override
    public void add(T t) {
        agg = agg + val.apply(t);
    }

    @Override
    public Object getAccumulated(int i) {
        return agg;
    }

    @Override
    public void reset() {
        agg = 0.0;
    }

    @Override
    public int resultCount() {
        return 1;
    }
}
