package Meta4Framework.A;

import java.util.function.BiFunction;

public class IntAgg<T> implements Reducer<T> {

    Integer agg;
    BiFunction<T, Integer, Integer> val;

    public IntAgg(BiFunction<T, Integer, Integer> val) {
        this.val = val;
        reset();
    }

    @Override
    public void add(T t) {
        agg = val.apply(t, agg);
    }

    @Override
    public Object getAccumulated(int i) {
        return agg;
    }

    @Override
    public void reset() {
        agg = 0;
    }

    @Override
    public int resultCount() {
        return 1;
    }
}
