package Meta4Framework.A;

import java.util.function.Function;

public class IntMax<T> implements Reducer<T> {

    Integer agg;
    String  name;
    Function<T, Integer> val;
    Function<T, String> id;

    public IntMax(Function<T,String> id, Function<T, Integer> val) {
        this.val = val;
        this.id = id;
        reset();
    }

    @Override
    public void add(T t) {
        int result = val.apply(t);
        if (result>agg) {
            agg = result;
            name = id.apply(t);
        }
    }

    @Override
    public Object getAccumulated(int i) {
        return (i==0)?name:agg;
    }

    @Override
    public void reset() {
        agg = 0;
        name = null;
    }

    @Override
    public int resultCount() {
        return 2;
    }
}
