package C2;

import org.junit.Test;
import M4.CDSpecUnion;
import M4.CDSpec2Png;

/**
 *
 * @author don
 */
public class CDSpecUnionTest {
    static final String TestData = "test/C2/TestData/";
    static final String Correct = "test/C2/Correct/";
    static final String Trash = "trash/";
    static final String outfile = Trash + "out.cdspec.pl";
    static final String pngfile = Trash + "out.png";
    static final String cdspecEnd = ".cdspec.pl";
    
    public CDSpecUnionTest() {
    }
    
    private String tf(String M) {
        return TestData+M+cdspecEnd;
    }
    
    private String of(String M) {
        return Trash + M + cdspecEnd;
    }
    
    private String op(String M) {
        return Trash + M + ".class.png";
    }
    
    private String cf(String M) {
        return Correct + M + cdspecEnd;
    }
    
    private void doit(String Accum, String newCDspec, String AppName, boolean png) throws Exception {
        CDSpecUnion.main(Accum,tf(newCDspec),of(AppName));        
        if (png) { CDSpec2Png.main(of(AppName),op(AppName)); }
        RegTest.Utility.validate(of(AppName), Correct+AppName+cdspecEnd, false);
    }
    
    @Test
    public void forward1() throws Exception {
        doit(tf("PD0"),"PD1","V1", false);
    }
    
    @Test
    public void forward2() throws Exception {
        doit(cf("V1"),"PD2","V2",false);
    }
    
    @Test
    public void forward3() throws Exception {
        doit(cf("V2"),"PD3","V3",true);
    }
    
    @Test
    public void star() throws Exception {
        doit(tf("starN2"),"starN3","starV3",false);
    }
    
    @Test
    public void starV() throws Exception {
        M4.CDSpecUnion.main(tf("starV1"),tf("starN3"),"starV2");
        RegTest.Utility.validate("starV2"+cdspecEnd, Correct+"starV2"+cdspecEnd, false);
    }
    
}
