package LineParsers;

import M4Parsing.LineParsers.CDLineParsers;
import CD.CDSpec;
import java.util.LinkedList;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author don
 */
public class ClassDiagramLineTest {
    
    public ClassDiagramLineTest() {
    }
    
    public void doit(String line, String name) {
        try {
            CDSpec os = CDLineParsers.parseClassDiagramLine(line, 5);
            if (!name.equals(os.getName()))
                fail();
        } catch(RuntimeException ex) {
            System.err.println(ex.getMessage());
            fail();
        }
    }
    
    public void doitErr(String line, String msg) {
        try {
            CDSpec os = CDLineParsers.parseClassDiagramLine(line, 5);
        } catch(RuntimeException ex) {
            String e = ex.getMessage().trim().replace("\n","");
            if (msg.trim().equals(e))
                return;
            System.out.println(e);
            System.out.println(msg);
        }
        fail();
    }

    @Test
    public void t1() {
        doit("classDiagram x.","x");
    }
    
    @Test 
    public void t2() { 
        doit("classDiagram     z     .     ","z");
    }
    
    @Test 
    public void b1() {
        doitErr("classDiagam(x,[y,z,w]).",
                "line 5: parse error 'classDiagram' expected at >>classDiagam(x,[y,z,w]).");
    }
    
    @Test 
    public void b2() { 
        doitErr("classDiagram(z,[]).","line 5: parse error 'name' expected at >>(z,[]).");
    }  
}
