package Meta4;

import java.io.IOException;
import org.junit.Test;

public class AllTest extends Common.SharedDecls {
    public static String Correct = "test/Meta4/Correct/"+Meta4.Main.AoclDir+"/";        //"../ATLExample/src/Aocl/Family/";
    public static String TestData = "test/Meta4/TestData/";
           
    
    public AllTest() { }
    
    @Test
    public void alleg() throws IOException{
        String f="Alleg";
        Main.main(TestData+f+cdspecEnd);
        String[] array = {"Database.java", "Alleg.schema.pl",
                          "Dept.java", "DeptTable.java", 
                          "Div.java", "DivTable.java", 
                          "Emp.java", "EmpTable.java", 
                          "Anc.java", "AncTable.java",
                          "Job.java", "JobTable.java",
                          "Lang.java"};
        for (String s: array) {
           RegTest.Utility.validate(AoclDir+f+slash+s, Correct+f+slash+s.replace("java","jav"), false);
        }
    }
    
    @Test
    public void family() throws IOException{
        String f="Family";
        Main.main(TestData+f+cdspecEnd);
        String[] array = {"Database.java", "family.java",
                          "familyTable.java", "member.java",
                          "memberTable.java", "Family.schema.pl",
                          "Lang.java"};
        for (String s: array) {
           RegTest.Utility.validate(AoclDir+f+slash+s, Correct+f+slash+s.replace("java","jav"), false);
        }
    }
    
    @Test
    public void person() throws IOException{
        String f="Person";
        Main.main(TestData+f+cdspecEnd);
        String[] array = {"Database.java", "person.java",
                          "personTable.java", "male.java",
                          "maleTable.java", "female.java",
                          "femaleTable.java", "Person.schema.pl",
                          "Lang.java"};
        for (String s: array) {
           RegTest.Utility.validate(AoclDir+f+slash+s, Correct+f+slash+s.replace("java","jav"), false);
        }
    }
    
   
    @Test
    public void star() throws IOException{
        String f="Star";
        Main.main(TestData+f+cdspecEnd);
        String[] array = {"Database.java","Lang.java",
            "X.java","XTable.java", 
            "Y.java","YTable.java", 
            "Z.java", "ZTable.java",
            "C.java","CTable.java",
            "W.java","WTable.java",
            "Y.java","YTable.java",
            "wc.java","wcTable.java",
            "yc.java","ycTable.java",
            "zc.java","zcTable.java",
            "star.schema.pl"};
        for (String s: array) {
           RegTest.Utility.validate(AoclDir+f+slash+s, Correct+f+slash+s.replace("java","jav"), false);
        }
    }
    
    @Test
    public void startrek() throws IOException{
        String f="startrek";
        Main.main(TestData+f+cdspecEnd);
        String[] array = {"Database.java","Lang.java",
            "crewman.java","crewmanTable.java", 
            "officer.java","officerTable.java", 
            "medical.java", "medicalTable.java",
            "post.java", "postTable.java",
            "asg.java", "asgTable.java",
            "startrek.schema.pl"};
        for (String s: array) {
           RegTest.Utility.validate(AoclDir+f+slash+s, Correct+f+slash+s.replace("java","jav"), false);
        }
    }

}
