package Aocl.Alleg;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Anc extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Anc"; }

    public <TABLE> TABLE applyAnc(Function<Anc,TABLE> f) { return f.apply(this); }

    public Emp parOf;
    protected String _parOf;  // needed by database loader
    public Emp chldOf;
    protected String _chldOf;  // needed by database loader

    public Anc(String id, Emp parOf, Emp chldOf) {
       this.id = id;
       this.parOf = parOf;
       this.chldOf = chldOf;
    }

    // constructors used in database loading
    protected Anc() {}

    public Anc(String id) {
       this.id = id;
       this.parOf = null;
       this.chldOf = null;
    }

    private Anc initFields(Tuple t) {
       id = t.get("id");
       _parOf = t.get("parOf");
       _chldOf = t.get("chldOf");
       return this;
    }

    public static Anc make(Tuple t) {
       return new Anc().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
       if(!_parOf.equals("null"))
           parOf = db.Emp.getTuple(_parOf,er);
       if(!_chldOf.equals("null"))
           chldOf = db.Emp.getTuple(_chldOf,er);
    }
    // end of methods used for loading a database

    static final String fmt = "Anc(%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,__(parOf),__(chldOf));
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,__(parOf),__(chldOf));
    }

    public AncTable toAncTable() { return new AncTable(db,this); }
}
