package Aocl.Alleg;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Alleg.Lang.*;

public class DivTable extends TaBle<Database,Div,DivTable> {
    @Override
    public String TupleTypeName() { return "Div"; }

    public <TABLE> TABLE applyDiv(Function<DivTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public DivTable(Database db) {
        this(db,null);
    }

    public DivTable(Database db, Div t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static DivTable BaseRelation(Database db) {
        DivTable tab = new DivTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<Div> tuples() {
        return tuples;
    }

    @Override
    public DivTable New() { return new DivTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       Div r = new Div(t.get("id"),t.get("name"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(Div t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(Div t) {
       t.hasDept().delete(); //b1
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(Div,[id,name]).");
    }

    @Override
    public String pformat() { return Div.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0;
       for (Div a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.name).length()+2);
       }
       return String.format("Div(!%ds,!%ds).\n",f0,f1).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable name() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.name)));
       return st;
    }

    public DeptTable hasDept() {
       LinkedList<Div> tups = tuples();
       DeptTable result = new DeptTable(db);
       for(Dept a : db.Dept.tuples()) {
          if(tups.contains(a.inDiv) && !result.contains(a)) {
             result.add(a);
          }
       }
       return result; // diamondRight
   }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
