package Aocl.Alleg;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Alleg.Lang.*;

public class EmpTable extends TaBle<Database,Emp,EmpTable> {
    @Override
    public String TupleTypeName() { return "Emp"; }

    public <TABLE> TABLE applyEmp(Function<EmpTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public EmpTable(Database db) {
        this(db,null);
    }

    public EmpTable(Database db, Emp t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static EmpTable BaseRelation(Database db) {
        EmpTable tab = new EmpTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<Emp> tuples() {
        return tuples;
    }

    @Override
    public EmpTable New() { return new EmpTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       Emp r = new Emp(t.get("id"),t.get("name"),t.getInt("age"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(Emp t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(Emp t) {
       db.Anc.select(x->x.parOf==t || x.chldOf==t).delete(); //b5
       db.Job.select(x->x.employs==t).delete(); //b6
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(Emp,[id,name,age:int]).");
    }

    @Override
    public String pformat() { return Emp.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0;
       for (Emp a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.name).length()+2);
          f2 = Math.max(f2,(""+a.age).length()+2);
       }
       return String.format("Emp(!%ds,!%ds,!%dd).\n",f0,f1,f2).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable name() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.name)));
       return st;
    }

    public INTTable age() {
       INTTable st = new INTTable(db);
       tuples.forEach(t -> st.add(new INT(t.age)));
       return st;
    }

    public EmpTable chldOf() {
       LinkedList<Emp> tups = tuples();
       EmpTable result = new EmpTable(db);
       for(Anc r : db.Anc.tuples()) {
          if(tups.contains(r.parOf) && !result.contains(r.chldOf)) {
             result.add(r.chldOf);
          }
       }
       return result; // nmLeft
    }

    public EmpTable parOf() {
       LinkedList<Emp> tups = tuples();
       EmpTable result = new EmpTable(db);
       for(Anc r : db.Anc.tuples()) {
          if(tups.contains(r.chldOf) && !result.contains(r.parOf)) {
             result.add(r.parOf);
          }
       }
       return result; // nmLeft
    }

    public DeptTable worksin() {
       LinkedList<Emp> tups = tuples();
       DeptTable result = new DeptTable(db);
       for(Job r : db.Job.tuples()) {
          if(tups.contains(r.employs) && !result.contains(r.worksin)) {
             result.add(r.worksin);
          }
       }
       return result; // nmLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
