package Aocl.Alleg;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Job extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Job"; }

    public <TABLE> TABLE applyJob(Function<Job,TABLE> f) { return f.apply(this); }

    public Emp employs;
    protected String _employs;  // needed by database loader
    public Dept worksin;
    protected String _worksin;  // needed by database loader

    public Job(String id, Emp employs, Dept worksin) {
       this.id = id;
       this.employs = employs;
       this.worksin = worksin;
    }

    // constructors used in database loading
    protected Job() {}

    public Job(String id) {
       this.id = id;
       this.employs = null;
       this.worksin = null;
    }

    private Job initFields(Tuple t) {
       id = t.get("id");
       _employs = t.get("employs");
       _worksin = t.get("worksin");
       return this;
    }

    public static Job make(Tuple t) {
       return new Job().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
       if(!_employs.equals("null"))
           employs = db.Emp.getTuple(_employs,er);
       if(!_worksin.equals("null"))
           worksin = db.Dept.getTuple(_worksin,er);
    }
    // end of methods used for loading a database

    static final String fmt = "Job(%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,__(employs),__(worksin));
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,__(employs),__(worksin));
    }

    public JobTable toJobTable() { return new JobTable(db,this); }
}
