package Aocl.Family;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class family extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "family"; }

    public <TABLE> TABLE applyfamily(Function<family,TABLE> f) { return f.apply(this); }

    public String lastName;  
    public member fatherid;
    protected String _fatherid;  // needed by database loader
    public member motherid;
    protected String _motherid;  // needed by database loader

    public family(String id, String lastName, member fatherid, member motherid) {
       this.id = id;
       this.lastName = lastName;
       this.fatherid = fatherid;
       this.motherid = motherid;
    }

    // constructors used in database loading
    protected family() {}

    public family(String id, String lastName) {
       this.id = id;
       this.lastName = lastName;
       this.fatherid = null;
       this.motherid = null;
    }

    private family initFields(Tuple t) {
       id = t.get("id");
       lastName = t.get("lastName");
       _fatherid = t.get("fatherid");
       _motherid = t.get("motherid");
       return this;
    }

    public static family make(Tuple t) {
       return new family().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
       if(!_fatherid.equals("null"))
           fatherid = db.member.getTuple(_fatherid,er);
       if(!_motherid.equals("null"))
           motherid = db.member.getTuple(_motherid,er);
    }
    // end of methods used for loading a database

    static final String fmt = "family(%s,%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,q(lastName),__(fatherid),__(motherid));
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,q(lastName),__(fatherid),__(motherid));
    }

    public memberTable sons() {
       memberTable result = new memberTable(db);
       for(member a : db.member.tuples()) {
          if(a.sonOf==this) {
             result.add(a);
          }
       }
       return result; ///diamondRight
   }

    public memberTable daughters() {
       memberTable result = new memberTable(db);
       for(member a : db.member.tuples()) {
          if(a.daughterOf==this) {
             result.add(a);
          }
       }
       return result; ///diamondRight
   }

    public memberTable fatherid() {
       return new memberTable(db,this.fatherid);
    }  // diamondleft

    public memberTable motherid() {
       return new memberTable(db,this.motherid);
    }  // diamondleft

    public member fatherid_() {
       return this.fatherid;
    }  // diamondleft

    public member motherid_() {
       return this.motherid;
    }  // diamondleft

    public familyTable tofamilyTable() { return new familyTable(db,this); }
}
