package Aocl.Family;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Family.Lang.*;

public class familyTable extends TaBle<Database,family,familyTable> {
    @Override
    public String TupleTypeName() { return "family"; }

    public <TABLE> TABLE applyfamily(Function<familyTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public familyTable(Database db) {
        this(db,null);
    }

    public familyTable(Database db, family t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static familyTable BaseRelation(Database db) {
        familyTable tab = new familyTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<family> tuples() {
        return tuples;
    }

    @Override
    public familyTable New() { return new familyTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       family r = new family(t.get("id"),t.get("lastName"));
       r._fatherid = t.get("fatherid");
       r._motherid = t.get("motherid");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(family t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(family t) {
       t.sons().forEach(x->x.sonOf=null); //b3
       t.daughters().forEach(x->x.daughterOf=null); //b3
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(family,[id,'lastName',fatherid:member,motherid:member]).");
    }

    @Override
    public String pformat() { return family.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0, f3=0;
       for (family a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.lastName).length()+2);
          f2 = Math.max(f2,a.fatherid==null?4:a.fatherid.id.length());
          f3 = Math.max(f3,a.motherid==null?4:a.motherid.id.length());
       }
       return String.format("family(!%ds,!%ds,!%ds,!%ds).\n",f0,f1,f2,f3).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable lastName() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.lastName)));
       return st;
    }

    public memberTable sons() {
       LinkedList<family> tups = tuples();
       memberTable result = new memberTable(db);
       for(member a : db.member.tuples()) {
          if(a.sonOf==null) continue;
          if(tups.contains(a.sonOf) && !result.contains(a)) {
             result.add(a);
          }
       }
       return result; // diamondRight
   }

    public memberTable daughters() {
       LinkedList<family> tups = tuples();
       memberTable result = new memberTable(db);
       for(member a : db.member.tuples()) {
          if(a.daughterOf==null) continue;
          if(tups.contains(a.daughterOf) && !result.contains(a)) {
             result.add(a);
          }
       }
       return result; // diamondRight
   }

    public memberTable fatherid() {
       memberTable result = new memberTable(db);
       for (family w : tuples()) {
          if (!result.contains(w.fatherid))
              result.add(w.fatherid);
       }
       return result; // diamondLeft
    }

    public memberTable motherid() {
       memberTable result = new memberTable(db);
       for (family w : tuples()) {
          if (!result.contains(w.motherid))
              result.add(w.motherid);
       }
       return result; // diamondLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
