package Aocl.Family;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class member extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "member"; }

    public <TABLE> TABLE applymember(Function<member,TABLE> f) { return f.apply(this); }

    public String firstName;  
    public family sonOf;
    protected String _sonOf;  // needed by database loader
    public family daughterOf;
    protected String _daughterOf;  // needed by database loader

    public member(String id, String firstName, family sonOf, family daughterOf) {
       this.id = id;
       this.firstName = firstName;
       this.sonOf = sonOf;
       this.daughterOf = daughterOf;
    }

    // constructors used in database loading
    protected member() {}

    public member(String id, String firstName) {
       this.id = id;
       this.firstName = firstName;
       this.sonOf = null;
       this.daughterOf = null;
    }

    private member initFields(Tuple t) {
       id = t.get("id");
       firstName = t.get("firstName");
       _sonOf = t.get("sonOf");
       _daughterOf = t.get("daughterOf");
       return this;
    }

    public static member make(Tuple t) {
       return new member().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
       if(!_sonOf.equals("null"))
           sonOf = db.family.getTuple(_sonOf,er);
       if(!_daughterOf.equals("null"))
           daughterOf = db.family.getTuple(_daughterOf,er);
    }
    // end of methods used for loading a database

    static final String fmt = "member(%s,%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,q(firstName),__(sonOf),__(daughterOf));
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,q(firstName),__(sonOf),__(daughterOf));
    }

    public familyTable sonOf() {
       return new familyTable(db,this.sonOf);
    }  // diamondleft

    public familyTable daughterOf() {
       return new familyTable(db,this.daughterOf);
    }  // diamondleft

    public familyTable familyfather() {
       familyTable result = new familyTable(db);
       for(family a : db.family.tuples()) {
          if(a.fatherid==this) {
             result.add(a);
          }
       }
       return result; ///diamondRight
   }

    public familyTable familymother() {
       familyTable result = new familyTable(db);
       for(family a : db.family.tuples()) {
          if(a.motherid==this) {
             result.add(a);
          }
       }
       return result; ///diamondRight
   }

    public memberTable tomemberTable() { return new memberTable(db,this); }
}
