package Aocl.Family;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Family.Lang.*;

public class memberTable extends TaBle<Database,member,memberTable> {
    @Override
    public String TupleTypeName() { return "member"; }

    public <TABLE> TABLE applymember(Function<memberTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public memberTable(Database db) {
        this(db,null);
    }

    public memberTable(Database db, member t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static memberTable BaseRelation(Database db) {
        memberTable tab = new memberTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<member> tuples() {
        return tuples;
    }

    @Override
    public memberTable New() { return new memberTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       member r = new member(t.get("id"),t.get("firstName"));
       r._sonOf = t.get("sonOf");
       r._daughterOf = t.get("daughterOf");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(member t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(member t) {
       t.familyfather().delete(); //b1
       t.familymother().delete(); //b1
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(member,[id,'firstName',sonOf:opt family,daughterOf:opt family]).");
    }

    @Override
    public String pformat() { return member.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0, f3=0;
       for (member a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.firstName).length()+2);
          f2 = Math.max(f2,a.sonOf==null?4:a.sonOf.id.length());
          f3 = Math.max(f3,a.daughterOf==null?4:a.daughterOf.id.length());
       }
       return String.format("member(!%ds,!%ds,!%ds,!%ds).\n",f0,f1,f2,f3).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable firstName() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.firstName)));
       return st;
    }

    public familyTable sonOf() {
       familyTable result = new familyTable(db);
       for (member w : tuples()) {
          if (w.sonOf==null) continue;
          if (!result.contains(w.sonOf))
              result.add(w.sonOf);
       }
       return result; // diamondLeft
    }

    public familyTable daughterOf() {
       familyTable result = new familyTable(db);
       for (member w : tuples()) {
          if (w.daughterOf==null) continue;
          if (!result.contains(w.daughterOf))
              result.add(w.daughterOf);
       }
       return result; // diamondLeft
    }

    public familyTable familyfather() {
       LinkedList<member> tups = tuples();
       familyTable result = new familyTable(db);
       for(family a : db.family.tuples()) {
          if(tups.contains(a.fatherid) && !result.contains(a)) {
             result.add(a);
          }
       }
       return result; // diamondRight
   }

    public familyTable familymother() {
       LinkedList<member> tups = tuples();
       familyTable result = new familyTable(db);
       for(family a : db.family.tuples()) {
          if(tups.contains(a.motherid) && !result.contains(a)) {
             result.add(a);
          }
       }
       return result; // diamondRight
   }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
