package Aocl.Person;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Person.Lang.*;

public class femaleTable extends TaBle<Database,female,femaleTable> {
    @Override
    public String TupleTypeName() { return "female"; }

    public <TABLE> TABLE applyfemale(Function<femaleTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public femaleTable(Database db) {
        this(db,null);
    }

    public femaleTable(Database db, female t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static femaleTable BaseRelation(Database db) {
        femaleTable tab = new femaleTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<female> tuples() {
        return tuples;
    }

    @Override
    public femaleTable New() { return new femaleTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       female r = new female(t.get("id"),t.get("fullName"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(female t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(female t) {
       db.person.cascadingDeleteLocal((person) t); // delete person associations
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(female,[id,'fullName']).");
    }

    @Override
    public String pformat() { return female.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0;
       for (female a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.fullName).length()+2);
       }
       return String.format("female(!%ds,!%ds).\n",f0,f1).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable fullName() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.fullName)));
       return st;
    }

   /* the following methods cast a subtable into a supertable */

   public personTable toPersonTable() {
      personTable tb = new personTable(db);
      for (female t : tuples()) {
         tb.add(t);
      }
      return tb;
   }

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
