package Aocl.Person;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Person.Lang.*;

public class personTable extends TaBle<Database,person,personTable> {
    @Override
    public String TupleTypeName() { return "person"; }

    public <TABLE> TABLE applyperson(Function<personTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public personTable(Database db) {
        this(db,null);
    }

    public personTable(Database db, person t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static personTable BaseRelation(Database db) {
        personTable tab = new personTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<person> tuples() {
        if (computedTable)
            return tuples;
        LinkedList<person> all = new LinkedList<>();
        all.addAll(db.male.tuples());
        all.addAll(db.female.tuples());
        return all;
    }

    @Override
    public personTable New() { return new personTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       person r = new person(t.get("id"),t.get("fullName"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(person t) {
       if (t instanceof male) return db.male.delete((male) t);
       if (t instanceof female) return db.female.delete((female) t);
       return false;
    }

    @Override
    public void cascadingDeleteLocal(person t) {
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(person,[id,'fullName']).");
    }

    @Override
    public String pformat() { return person.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0;
       for (person a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.fullName).length()+2);
       }
       return String.format("person(!%ds,!%ds).\n",f0,f1).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable fullName() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.fullName)));
       return st;
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   public maleTable toMaleTable() {
      maleTable tb = new maleTable(db);
      for (person t : tuples()) {
         if (t instanceof male) tb.add((male) t);
      }
      return tb;
   }

   public femaleTable toFemaleTable() {
      femaleTable tb = new femaleTable(db);
      for (person t : tuples()) {
         if (t instanceof female) tb.add((female) t);
      }
      return tb;
   }

   /* end of filtering methods */

}
