package Aocl.Star;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class C extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "C"; }

    public <TABLE> TABLE applyC(Function<C,TABLE> f) { return f.apply(this); }

    public String c1;  
    public String D_d;  

    public C(String id, String c1, String D_d) {
       this.id = id;
       this.c1 = c1;
       this.D_d = D_d;
    }

    // constructors used in database loading
    protected C() {}

    private C initFields(Tuple t) {
       id = t.get("id");
       c1 = t.get("c1");
       D_d = t.get("D_d");
       return this;
    }

    public static C make(Tuple t) {
       return new C().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database

    static final String fmt = "C(%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,c1,D_d);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,c1,D_d);
    }

    public XTable cx() {
       XTable result = new XTable(db);
       for(xc r : db.xc.tuples()) {
          if(r.xc==this && !result.contains(r.cx)) {
             result.add(r.cx);
          }
       }
       return result; // nmleft
    }

    public YTable cy() {
       YTable result = new YTable(db);
       for(yc r : db.yc.tuples()) {
          if(r.yc==this && !result.contains(r.cy)) {
             result.add(r.cy);
          }
       }
       return result; // nmleft
    }

    public ZTable cz() {
       ZTable result = new ZTable(db);
       for(zc r : db.zc.tuples()) {
          if(r.zc==this && !result.contains(r.cz)) {
             result.add(r.cz);
          }
       }
       return result; // nmleft
    }

    public WTable cw() {
       WTable result = new WTable(db);
       for(wc r : db.wc.tuples()) {
          if(r.wc==this && !result.contains(r.cw)) {
             result.add(r.cw);
          }
       }
       return result; // nmleft
    }

    public CTable toCTable() { return new CTable(db,this); }
}
