package Aocl.Star;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Star.Lang.*;

public class CTable extends TaBle<Database,C,CTable> {
    @Override
    public String TupleTypeName() { return "C"; }

    public <TABLE> TABLE applyC(Function<CTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public CTable(Database db) {
        this(db,null);
    }

    public CTable(Database db, C t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static CTable BaseRelation(Database db) {
        CTable tab = new CTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<C> tuples() {
        return tuples;
    }

    @Override
    public CTable New() { return new CTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       C r = new C(t.get("id"),t.get("c1"),t.get("D_d"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(C t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(C t) {
       db.xc.select(x->x.xc==t).delete(); //b7
       db.yc.select(x->x.yc==t).delete(); //b7
       db.zc.select(x->x.zc==t).delete(); //b7
       db.wc.select(x->x.wc==t).delete(); //b7
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(C,[id,c1,D_d]).");
    }

    @Override
    public String pformat() { return C.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0;
       for (C a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.c1).length()+2);
          f2 = Math.max(f2,(""+a.D_d).length()+2);
       }
       return String.format("C(!%ds,!%ds,!%ds).\n",f0,f1,f2).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable c1() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.c1)));
       return st;
    }

    public STRINGTable D_d() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.D_d)));
       return st;
    }

    public XTable cx() {
       LinkedList<C> tups = tuples();
       XTable result = new XTable(db);
       for(xc r : db.xc.tuples()) {
          if(tups.contains(r.xc) && !result.contains(r.cx)) {
             result.add(r.cx);
          }
       }
       return result; // nmLeft
    }

    public YTable cy() {
       LinkedList<C> tups = tuples();
       YTable result = new YTable(db);
       for(yc r : db.yc.tuples()) {
          if(tups.contains(r.yc) && !result.contains(r.cy)) {
             result.add(r.cy);
          }
       }
       return result; // nmLeft
    }

    public ZTable cz() {
       LinkedList<C> tups = tuples();
       ZTable result = new ZTable(db);
       for(zc r : db.zc.tuples()) {
          if(tups.contains(r.zc) && !result.contains(r.cz)) {
             result.add(r.cz);
          }
       }
       return result; // nmLeft
    }

    public WTable cw() {
       LinkedList<C> tups = tuples();
       WTable result = new WTable(db);
       for(wc r : db.wc.tuples()) {
          if(tups.contains(r.wc) && !result.contains(r.cw)) {
             result.add(r.cw);
          }
       }
       return result; // nmLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
