package Aocl.Star;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Star.Lang.*;

public class XTable extends TaBle<Database,X,XTable> {
    @Override
    public String TupleTypeName() { return "X"; }

    public <TABLE> TABLE applyX(Function<XTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public XTable(Database db) {
        this(db,null);
    }

    public XTable(Database db, X t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static XTable BaseRelation(Database db) {
        XTable tab = new XTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<X> tuples() {
        return tuples;
    }

    @Override
    public XTable New() { return new XTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       X r = new X(t.get("id"),t.get("x1"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(X t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(X t) {
       db.xc.select(x->x.cx==t).delete(); //b6
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(X,[id,x1]).");
    }

    @Override
    public String pformat() { return X.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0;
       for (X a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.x1).length()+2);
       }
       return String.format("X(!%ds,!%ds).\n",f0,f1).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable x1() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.x1)));
       return st;
    }

    public CTable xc() {
       LinkedList<X> tups = tuples();
       CTable result = new CTable(db);
       for(xc r : db.xc.tuples()) {
          if(tups.contains(r.cx) && !result.contains(r.xc)) {
             result.add(r.xc);
          }
       }
       return result; // nmLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
