package Aocl.Star;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Y extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Y"; }

    public <TABLE> TABLE applyY(Function<Y,TABLE> f) { return f.apply(this); }

    public String y1;  

    public Y(String id, String y1) {
       this.id = id;
       this.y1 = y1;
    }

    // constructors used in database loading
    protected Y() {}

    private Y initFields(Tuple t) {
       id = t.get("id");
       y1 = t.get("y1");
       return this;
    }

    public static Y make(Tuple t) {
       return new Y().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database

    static final String fmt = "Y(%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,y1);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,y1);
    }

    public CTable yc() {
       CTable result = new CTable(db);
       for(yc r : db.yc.tuples()) {
          if(r.cy==this && !result.contains(r.yc)) {
             result.add(r.yc);
          }
       }
       return result; // nmleft
    }

    public YTable toYTable() { return new YTable(db,this); }
}
