package Aocl.Star;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Z extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Z"; }

    public <TABLE> TABLE applyZ(Function<Z,TABLE> f) { return f.apply(this); }

    public String z1;  

    public Z(String id, String z1) {
       this.id = id;
       this.z1 = z1;
    }

    // constructors used in database loading
    protected Z() {}

    private Z initFields(Tuple t) {
       id = t.get("id");
       z1 = t.get("z1");
       return this;
    }

    public static Z make(Tuple t) {
       return new Z().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database

    static final String fmt = "Z(%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,z1);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,z1);
    }

    public CTable zc() {
       CTable result = new CTable(db);
       for(zc r : db.zc.tuples()) {
          if(r.cz==this && !result.contains(r.zc)) {
             result.add(r.zc);
          }
       }
       return result; // nmleft
    }

    public ZTable toZTable() { return new ZTable(db,this); }
}
