package Aocl.Star;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Star.Lang.*;

public class ZTable extends TaBle<Database,Z,ZTable> {
    @Override
    public String TupleTypeName() { return "Z"; }

    public <TABLE> TABLE applyZ(Function<ZTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public ZTable(Database db) {
        this(db,null);
    }

    public ZTable(Database db, Z t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static ZTable BaseRelation(Database db) {
        ZTable tab = new ZTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<Z> tuples() {
        return tuples;
    }

    @Override
    public ZTable New() { return new ZTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       Z r = new Z(t.get("id"),t.get("z1"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(Z t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(Z t) {
       db.zc.select(x->x.cz==t).delete(); //b6
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(Z,[id,z1]).");
    }

    @Override
    public String pformat() { return Z.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0;
       for (Z a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.z1).length()+2);
       }
       return String.format("Z(!%ds,!%ds).\n",f0,f1).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable z1() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.z1)));
       return st;
    }

    public CTable zc() {
       LinkedList<Z> tups = tuples();
       CTable result = new CTable(db);
       for(zc r : db.zc.tuples()) {
          if(tups.contains(r.cz) && !result.contains(r.zc)) {
             result.add(r.zc);
          }
       }
       return result; // nmLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
