package Aocl.Star;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Star.Lang.*;

public class wcTable extends TaBle<Database,wc,wcTable> {
    @Override
    public String TupleTypeName() { return "wc"; }

    public <TABLE> TABLE applywc(Function<wcTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public wcTable(Database db) {
        this(db,null);
    }

    public wcTable(Database db, wc t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static wcTable BaseRelation(Database db) {
        wcTable tab = new wcTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<wc> tuples() {
        return tuples;
    }

    @Override
    public wcTable New() { return new wcTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       wc r = new wc(t.get("id"));
       r._cw = t.get("cw");
       r._wc = t.get("wc");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(wc t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(wc t) {
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(wc,[id,cw:W,wc:C]).");
    }

    @Override
    public String pformat() { return wc.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0;
       for (wc a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,a.cw==null?4:a.cw.id.length());
          f2 = Math.max(f2,a.wc==null?4:a.wc.id.length());
       }
       return String.format("wc(!%ds,!%ds,!%ds).\n",f0,f1,f2).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
