package Aocl.Star;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.Star.Lang.*;

public class xcTable extends TaBle<Database,xc,xcTable> {
    @Override
    public String TupleTypeName() { return "xc"; }

    public <TABLE> TABLE applyxc(Function<xcTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public xcTable(Database db) {
        this(db,null);
    }

    public xcTable(Database db, xc t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static xcTable BaseRelation(Database db) {
        xcTable tab = new xcTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<xc> tuples() {
        return tuples;
    }

    @Override
    public xcTable New() { return new xcTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       xc r = new xc(t.get("id"));
       r._cx = t.get("cx");
       r._xc = t.get("xc");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(xc t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(xc t) {
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(xc,[id,cx:X,xc:C]).");
    }

    @Override
    public String pformat() { return xc.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0;
       for (xc a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,a.cx.id.length());
          f2 = Math.max(f2,a.xc.id.length());
       }
       return String.format("xc(!%ds,!%ds,!%ds).\n",f0,f1,f2).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
