package Aocl.startrek;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;

public class officer extends crewman {
    @Override
    public String TupleTypeName() { return "officer"; }

    public <TABLE> TABLE applyofficer(Function<officer,TABLE> f) { return f.apply(this); }

    public String rank;  

    public officer(String id, String fname, String lname, String species, String rank) {
       this.id = id;
       this.fname = fname;
       this.lname = lname;
       this.species = species;
       this.rank = rank;
    }

    // constructors used in database loading
    protected officer() {}

    private officer initFields(Tuple t) {
       id = t.get("id");
       fname = t.get("fname");
       lname = t.get("lname");
       species = t.get("species");
       rank = t.get("rank");
       return this;
    }

    public static officer make(Tuple t) {
       return new officer().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database

    static final String fmt = "officer(%s,%s,%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,q(fname),q(lname),species,rank);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,q(fname),q(lname),species,rank);
    }

    public postTable onBoard() {
       postTable result = new postTable(db);
       for(asg r : db.asg.tuples()) {
          if(r.hasCrew==this && !result.contains(r.onBoard)) {
             result.add(r.onBoard);
          }
       }
       return result; // nmleft
    }

    public officerTable toofficerTable() { return new officerTable(db,this); }
}
