package Aocl.startrek;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.startrek.Lang.*;

public class officerTable extends TaBle<Database,officer,officerTable> {
    @Override
    public String TupleTypeName() { return "officer"; }

    public <TABLE> TABLE applyofficer(Function<officerTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public officerTable(Database db) {
        this(db,null);
    }

    public officerTable(Database db, officer t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static officerTable BaseRelation(Database db) {
        officerTable tab = new officerTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<officer> tuples() {
        return tuples;
    }

    @Override
    public officerTable New() { return new officerTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       officer r = new officer(t.get("id"),t.get("fname"),t.get("lname"),t.get("species"),t.get("rank"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(officer t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(officer t) {
       db.crewman.cascadingDeleteLocal((crewman) t); // delete crewman associations
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(officer,[id,'fname','lname',species,rank]).");
    }

    @Override
    public String pformat() { return officer.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0, f3=0, f4=0;
       for (officer a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.fname).length()+2);
          f2 = Math.max(f2,(""+a.lname).length()+2);
          f3 = Math.max(f3,(""+a.species).length()+2);
          f4 = Math.max(f4,(""+a.rank).length()+2);
       }
       return String.format("officer(!%ds,!%ds,!%ds,!%ds,!%ds).\n",f0,f1,f2,f3,f4).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable fname() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.fname)));
       return st;
    }

    public STRINGTable lname() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.lname)));
       return st;
    }

    public STRINGTable species() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.species)));
       return st;
    }

    public STRINGTable rank() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.rank)));
       return st;
    }

    public postTable onBoard() {
       LinkedList<officer> tups = tuples();
       postTable result = new postTable(db);
       for(asg r : db.asg.tuples()) {
          if(tups.contains(r.hasCrew) && !result.contains(r.onBoard)) {
             result.add(r.onBoard);
          }
       }
       return result; // nmLeft
    }

   /* the following methods cast a subtable into a supertable */

   public crewmanTable toCrewmanTable() {
      crewmanTable tb = new crewmanTable(db);
      for (officer t : tuples()) {
         tb.add(t);
      }
      return tb;
   }

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
