package Aocl.startrek;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Aocl.startrek.Lang.*;

public class postTable extends TaBle<Database,post,postTable> {
    @Override
    public String TupleTypeName() { return "post"; }

    public <TABLE> TABLE applypost(Function<postTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public postTable(Database db) {
        this(db,null);
    }

    public postTable(Database db, post t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static postTable BaseRelation(Database db) {
        postTable tab = new postTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<post> tuples() {
        return tuples;
    }

    @Override
    public postTable New() { return new postTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       post r = new post(t.get("id"),t.get("name"),t.get("kind"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(post t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(post t) {
       db.asg.select(x->x.onBoard==t).delete(); //b7
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(post,[id,'name','kind']).");
    }

    @Override
    public String pformat() { return post.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0;
       for (post a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.name).length()+2);
          f2 = Math.max(f2,(""+a.kind).length()+2);
       }
       return String.format("post(!%ds,!%ds,!%ds).\n",f0,f1,f2).replace("!","%");
    }

    /* the following methods do a column projection and a unique 'projection' */

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable name() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.name)));
       return st;
    }

    public STRINGTable kind() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.kind)));
       return st;
    }

    public crewmanTable hasCrew() {
       LinkedList<post> tups = tuples();
       crewmanTable result = new crewmanTable(db);
       for(asg r : db.asg.tuples()) {
          if(tups.contains(r.onBoard) && !result.contains(r.hasCrew)) {
             result.add(r.hasCrew);
          }
       }
       return result; // nmLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
